%ssrbc2.m

% Computation of the steady state by solving min F(x)'*W*F(x), where
% W is a weighting matrix, so as to find F(x)=0.


% Calculate steady state of model

% Features of data to match

sg=.2;
sn=.67;
sk=1-sn;
r=.01;
delta=.025;
gamma=.5;
sigma=1;
bstar=1/(1+r);
a=1;

cal=1;

if cal==1
nbar=.2;
last=nbar;
else
chi=5;
last=chi;
end

param=[cal sg sn a bstar gamma sigma delta last];


x=ones(4,1)

options=optimset;

[xsolve,fval]=fminsearch('Fss',x,options,param);


lamss=xsolve(1);
kss=xsolve(2);
css=xsolve(3);

if (cal==1)
    chi=xsolve(4);
    nss=nbar;
else
    nss=xsovle(4);
end;


% Compute some derivative information that will be used in linear system

derivinfo
