%  crashsys1.m

% ***********************************************************************
% The model is written as:
%
% A*y(t+1/t) = B*y(t) + C(F)*x(t/t),
%
% where C(F) = C0 + C1*F + C2*F^2 + ... + CN*F^N, where F is defined as the
% forward shift operator; i.e., F*x(k/t) = x(k+1/t).
%
% Output parameters:
% A
% B
% C = [C0, C1,..., CN]
% LPD = Array that contains locations of predetermined variables in the
%       y vector.
% 
% YLIST = Array of names of the elements of y (strings)
% XLIST = Array of names of the elements of x (strings)
% ny: Number of elements of y
% nx: Number of elements of x
% nlead: Number of leads of x(t+j/t) -- (i.e., n in the above equation).
% np: number of predetermined variables


% **********************
% LISTS OF VARIABLES
% AND ASSOCIATED INDICES
% **********************

ylist=['lam1 '
       'lam2 '
       '   k '];

xlist=['x'];


% **************** 
% system dimension 
% **************** 

ny=rows(ylist);
nx=rows(xlist);
nlead=0;

% ********************************* %
% DEFINING THE MATRICES A, B AND C  %
% ********************************* %
% 
% -----------------------------------------------
% Equations are written in the form
% A*Ey(t+1)|I(t) = B*Ey(t)|I(t) + C(F)*Ex(t)|I(t)
% where C(F) = C0 + C1F + ... + CnF^n
% -----------------------------------------------


% Initialize Matrices:

A=zeros(ny,ny);
B=zeros(ny,ny);
CF=zeros(ny,nx); 

examp=input('choose first example or second example');

mu=.9;

lpd=3;

A=[0 0 0
   0 0 0
   0 0 1]

C=[1
   2
   1];

if examp==1
    
B=[0 0 0
   0 0 0
   0 0 mu];

elseif examp==2
 B=[0 1 1
    0 1 2
    0 0 mu];

end

