function [A,B,CF,nx,lpd]=PREDKW(A,B,CF,nx,lpd,track,etype);

[s1 s2]=sort(etype);
nz=sum(etype==1);
ny=size(B);
ny=ny(1);

% Reorganize equations to place specified (elist==1)
% rows first.   These equations must have all zeros in A,
% a property which is checked.

A=A(s2,:);
B=B(s2,:);
CF=CF(s2,:);
[nr,nc]=size(CF);

checkA=max(max(abs(full(A(1:nz,:)))));
if (checkA>.000001)
    disp('non zero entry in specified equations')
end

nr=ny-nz;

K=B(1:nz,1:nz)\[B(1:nz,nz+1:ny) CF(1:nz,:)];
Kx=K(:,nr+1:nr+nc);
K=K(:,1:nr);

CF=[CF(nz+1:ny,:) zeros(nr,nx)]+...
    [-B(nz+1:ny,1:nz)*Kx zeros(nr,nx)] +...
    [zeros(nr,nx) A(nz+1:ny,1:nz)*Kx];


A=A(nz+1:ny,nz+1:ny)-A(nz+1:ny,1:nz)*K;
B=B(nz+1:ny,nz+1:ny)-B(nz+1:ny,1:nz)*K;

lpd=lpd-nz;

A=full(A);
B=full(B);

save PREDKW.mat K Kx nz