function [FACV]=FDFKW(M,PI,G,Vii,lags,ch,pts)

dos('del fdfkw.mat')
t1=clock;
% specify lags for filter autocovarieances

nlgs=max(size(lags));


% determine size of M matrix

nM=max(size(M));

% identity matrix of size of M

if (max(size(M))==1)
 IM=1;
else
 IM=eye(size(M));
end


% number of points at which Fourier transform is evaluated: 2*m

if (nargin <7)
  m=200;
else
  m=pts;
end

disp([num2str(m),' points used in Fourierl approximations'])

% set grid for omega in evaluating spectral density, etc.

bnd=-1+(1/(2*m));
om=bnd:(1/m):-bnd;
om=om*pi;

% define imaginary number
im=sqrt(-1);

if (nargin<6);
    sel=1;
    disp('No filter specified')
    disp(' ')
end

% Compute the transfer function of the selected filter

FILTTF


disp('computing power spectrum of filtered states')
disp('  ')
disp('  ')
nom=max(size(om));

for j=1:nom;
  % compute power spectrum of s
  temp = inv(exp(im*om(j))*IM-M);
  temp = (temp*G*Vii*G'*temp')/(2*pi);
  FSD(1:nM,1+(j-1)*nM:j*nM)=ftfil(j)*temp;
  % FSD(1:nM,1+(j-1)*nM:j*nM)=temp;
end

disp('computing the selected components of the')
disp('autocovariance generating function')
disp('of the filtered variables')

% To do this, we first define a matrix of
% indexing vectors (see PCMATLAB manual, p. 2-34).


for i=1:nom;
  IND(1:nM,(i-1)*nM+1:i*nM)=eye(nM);
end;

blags=[0 lags];

for n=1:nlgs+1;
    
disp(['lag =' num2str(blags(n))])

% loop over the elements of the power spectrum of the filtered states

for i=1:nM
 for j=1:nM

   % set indicator vector so to pick up i,j th elements of FSD
     ind=logical(IND(j,:));

   % get i,jth elements
     temp=FSD(i,ind);

   % To generate the term in the autocovaraince generating function of
   % of the filtered series: approximate the inverse fourier transform
   % integral to with tau=0

   tau=blags(n);

   %  Construct vector containing product of filter power spectrum and 
   %  the inverse Fourier transform weights, evaluated at pertinent lag:

   temp=temp.*(exp(im*om*tau));

   %  Sum these and weight by length of approximating segments to obtain
   %  approximation to integral:

   temp=sum(temp)*(pi/m);

   % put this in the relevant spot
   FSACV(i,j)=temp;

   end;  % row loop
end;     % column loop

% compute the acv term for the filtered variables:')

rPI=size(PI);
rPI=rPI(1); % number of rows in the PI matrix

FACV(1:rPI,(n-1)*rPI+1:n*rPI)=real(PI*FSACV*PI');

end;  % lag loop
t2=clock;
tm=etime(t2,t1);

save fdfkw.mat FACV lags 

disp(['computations completed by FDFKW.m'])
disp(['elapsed time = ' num2str(tm) ' seconds'])
