function [FSD,om]=SPECKW(M,PI,G,Vii,ch,pts)


% determine size of M matrix

nM=max(size(M));

% identity matrix of size of M

if (max(size(M))==1)
 IM=1;
else
 IM=eye(size(M));
end


% number of points at which Fourier transform is evaluated: 2*m

if (nargin <6)
  m=200;
else
  m=pts;
end

disp([num2str(m/2),' points used in spectrum calculations'])

% set grid for omega in evaluating spectral density, etc.
% Note that grid is one-sided here, reflecting focus
% on the diagonal elements of the matrix power spectrum

bnd=-1+(1/(2*m));
om=1/m:(1/m):-bnd;
om=om*pi;

% define imaginary number
im=sqrt(-1);

if (nargin<5);
    sel=1;
    disp('No filter specified')
    disp(' ')
else
    sel=0;
end

% Compute the transfer function of the selected filter

FILTTF

nom=max(size(om));

FSD=[];

for j=1:nom;
  % compute power spectrum 
  temp = inv(exp(im*om(j))*IM-M);
  temp = (temp*G*Vii*G'*temp')/(2*pi);
  temp = real(diag(PI*temp*PI'));
  FSD=[FSD temp];
end

