function [elist,count]=ADDEQN(name,elist,count,j);

% ADDEQN(name,elist,count,j);
%    Add an equation described by 'name' to a model that already has 
%    'count' equations and update the total number of equations.
%    Optionally add the equation description as name0j for j<10
%    and namej for j>=10.
%    
%    Examples:  [elist,count]=ADDEQN('IS curve',elist,count)
%               [elist,count]=ADDEQN('Lagged price',elist,count,3)
%
if nargin==4;
  if (j<10);
    llist = [name,'0',num2str(j)];
  else
    llist = [name,num2str(j)];
  end;
else
  llist=name;
end
  

if count>0
    elist=PAD(elist,llist);
else
    elist=llist;
end

count=count+1;