function [ylist,count,vargout]=ADDVAR(name,ylist,count,dtype,dtloc);

% [ylist,count,vargout]=ADDVAR(name,ylist,count,dtype,dtloc);
%
%    Add a variable described by 'name' to a model that already has 
%    'count' variables and update the total number of variables.
%    Optionally add information on derivative type (for numerical
%    derivative programs: 0 is for standard dervative and 1 for 
%    derivative (1/x)dx
%    
%    Examples:  [ylist,count]=ADDVAR('r',ylist,count)
%               [ylist,count]=ADDVAR('c',ylist,count,dtype,1)

llist=[];


count=count+1;
ylist=PAD(ylist,name);

if nargin>3

dtype=[dtype
    dtloc];
vargout=[dtype];

end


