function eqnbad=COMPAREABC(A1,A2,B1,B2,CF1,CF2,ylist,xlist,elist,nml)

if (nargin<10)
    nml=0;
end

ny=rows(ylist);
nx=rows(xlist);
nlead=cols(CF1);
nlead=nlead/nx;
nlead=nlead-1;

eqnbad=[];

% compare the A,B,C matrices of two models

[ne,junk]=size(A1);

for j=1:ne;
    
 % We want each equation of the two models to represent the same
 % restriction on the endogenous variables, but are not concerned 
 % with the scale of the coefficients. Hence, the first test is 
 % to determine if the vectors of coefficients are colinear.
 
 model1=[A1(j,:) B1(j,:) CF1(j,:)];
 model2=[A2(j,:) B2(j,:) CF2(j,:)];
 testeqn=[model1
            model2];
        
 % RANK TEST NEEDS TO BE IMPROVED       
 r=rank(testeqn,10^-4);
 
 % If the rank is less than two, then the equations are colinear
 % and need not be tested further.
 
 if (r<2)
     disp(['Equation ', num2str(j), ' is ok'])
 else
 
 if nml==1;
      [norm1,loc]=max(abs(model1));
      A1(j,:)=A1(j,:)/norm1;
      B1(j,:)=B1(j,:)/norm1;
      CF1(j,:)=CF1(j,:)/norm1;
      norm2=max(abs(model2));      
      A2(j,:)=A2(j,:)/norm2;
      B2(j,:)=B2(j,:)/norm2;
      CF2(j,:)=CF2(j,:)/norm2;
   end
   
 toldiff=10^-2;

 % Find sources of differences in equations
 % A equation
 
 ediff=(abs(A1(j,:)-A2(j,:)));
 tediff=ediff>toldiff; 
 bad=1:ny;
 bad=bad(logical(tediff));
 num=length(bad);
 
if (num>0)
   disp(['Discrepancy in A matrices: Eqn ',num2str(j)])  
   disp(['Variable, Model 1, Model 2']) 
   
   for k=1:num;
        disp([ylist(bad(k),:),'  ',num2str(A1(j,bad(k)),'%10.5f'),'  ',num2str(A2(j,bad(k)),'%10.5f')])
   end

end
 
 % B equation
 
 ediff=(abs(B1(j,:)-B2(j,:)));
 tediff=ediff>toldiff; 
 bad=1:ny;
 bad=bad(logical(tediff));
 num=length(bad);

if (num>0)
 disp(['Discrepancy in B matrices: Eqn ',num2str(j)])  
 disp(['Variable, Model 1, Model 2'])
    
    for k=1:num;
        disp([ylist(bad(k),:),'  ',num2str(B1(j,bad(k)),'%10.5f'),'  ',num2str(B2(j,bad(k)),'%10.5f')])
    end
 eqnbad=[eqnbad j];
end

for l=0:nlead;
     % B equation
 
 ediff=(abs(CF1(j,l*nx+1:(l+1)*nx)-CF2(j,l*nx+1:(l+1)*nx)));
 tediff=ediff>toldiff; 
 bad=1:nx;
 bad=bad(logical(tediff));
 num=length(bad);

if (num>0)
 disp(['Discrepancy in CF',num2str(l),' matrices: Eqn ',num2str(j)])  
 disp(['Variable, Model 1, Model 2'])
    
    for k=1:num;
        disp([xlist(bad(k),:),'  ',num2str(CF1(j,l*nx+bad(k)),'%10.5f'),'  ',num2str(CF2(j,l*nx+bad(k)),'%10.5f')])
    end
end

end
end

end