function [ylist,xlist]=MAKEID(ylist,xlist,fname);
% MAKEID.m
% make variable ids and store them in fname, e.g., 'id.mat'
% also make ylist and xlist the same width

% delete prior mat file

check=[fname,'.mat'];
chk=exist(check);

if (chk>0)
delete(check);
end

% *************************************************
% MAKE AND SAVE IDS
% *************************************************

ny=ROWS(ylist);

for i=1:ny;
    s=['i',ylist(i,:),'=',num2str(i),';'];
    eval(s);
end

if (nargin>1)
    
nx=ROWS(xlist);

for i=1:nx;
    s=['i',xlist(i,:),'=',num2str(i),';'];
    eval(s);
end
end

clear i;
clear s;

if (nargin<3);
disp('index variables saved in id.mat')
save id i*
else
disp(['index variables saved in ',fname,'.mat']) 
strng=['save ',fname,' i*'];
eval(strng)

end

% *************************************************
% Make ylist and xlist have same width
% *************************************************

widthy=COLS(ylist);
widthx=COLS(xlist);

ADDBL=[];

if widthy>widthx
    % need to pad xlist
    addbl=ones(1,(widthy-widthx))*32;
    addbl=char(addbl);
    for i=1:nx
        ADDBL=[ADDBL
               addbl];
    end
    xlist=[xlist ADDBL];
elseif widthy<widthx
    % need to pad ylist
    addbl=ones(1,(widthx-widthy))*32;
    addbl=char(addbl);
    for i=1:ny
        ADDBL=[ADDBL
               addbl];
    end
    ylist=[ylist ADDBL];
end
